<?php
/*
     Copyright (C) 2011  Likno Software

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/

defined( '_JEXEC' ) or die( 'Restricted access' );

jimport('joomla.application.helper' );
jimport('joomla.application' );
jimport('joomla.filesystem.file');
jimport('joomla.base.tree');

$controller = JRequest::getVar('controller', '');

require_once( JApplicationHelper::getPath( 'admin_html', 'com_allwebmenus' ) ); 

$task = JRequest::getVar( 'task', '' );

switch ($controller) {
	case 'awmmenuextract':
		switch ($task) {
			case 'submit':
				submit($option);
				break;
			case 'menuextractnext':
				HTML_allwebmenus::menuExtractNext($option);
				break;
			default:
				HTML_allwebmenus::menuExtractRoot($option);
				break;
		}
		break;
	case 'awmupload':
		switch ($task) {
			case 'submit':
				submit($option);
				break;
			case 'uploadmenunext':
				HTML_allwebmenus::uploadMenuNext($option);
				break;
			default:
				HTML_allwebmenus::uploadMenuRoot($option);
				break;
		}
		break;
	default:
		HTML_allwebmenus::defaultRoot();
		break;
}

$stack = array();

function geturl($HashNo, $params)
{
    $ch = curl_init();
    curl_setopt( $ch, CURLOPT_URL, "http://www.likno.com/addins/plugin-check.php" );
	curl_setopt( $ch, CURLOPT_POST, 1 );
    curl_setopt( $ch, CURLOPT_POSTFIELDS, $params );
    curl_setopt( $ch, CURLOPT_RETURNTRANSFER, 1 );
    $postResult = curl_exec($ch);
    return $postResult;
}

function submit($option) {
	global $stack;
	$menutype = JRequest::getVar( 'menutype', 'none', 'POST', 'STRING', JREQUEST_ALLOWHTML );
	$selectiontext = JRequest::getVar('selectionstext', array(), 'POST', 'array');
	$selectionlink = JRequest::getVar('selectionslink', array(), 'POST', 'array');
	$textopt = JRequest::getVar( 'textopt', 'none', 'POST', 'STRING', JREQUEST_ALLOWHTML );
	$linkopt = JRequest::getVar( 'linkopt', 'none', 'POST', 'STRING', JREQUEST_ALLOWHTML );
	$menutypeopt = JRequest::getVar( 'menutypeopt', 'none', 'POST', 'STRING', JREQUEST_ALLOWHTML );

	$database = null;		
	$database =& JFactory::getDBO();
	$sql = "DELETE FROM #__allwebmenus WHERE menutype='" . $menutype . "'";		
	$database->setQuery($sql);
	$database->query();
	
	if ($textopt=="all") {
		$sql = "INSERT INTO #__allwebmenus VALUES ('" . $menutype . "',0,1)";		
		$database->setQuery($sql);
		$database->query();		
	} else {
		if ($textopt=="select") {
			for ($i=0;$i<count($selectiontext);$i++) {
				$sql = "INSERT INTO #__allwebmenus VALUES ('" . $menutype . "'," . $selectiontext[$i] . ",1)";		
				$database->setQuery($sql);
				$database->query();		
			}
		}
	}
	if ($linkopt=="all") {
		$sql = "INSERT INTO #__allwebmenus VALUES ('" . $menutype . "',0,2)";		
		$database->setQuery($sql);
		$database->query();		
	} else {
		if ($linkopt=="select") {
			for ($i=0;$i<count($selectionlink);$i++) {
				$sql = "INSERT INTO #__allwebmenus VALUES ('" . $menutype . "'," . $selectionlink[$i] . ",2)";		
				$database->setQuery($sql);
				$database->query();		
			}
		}
	}
	if ($menutypeopt=="") $menutypeopt=0;
	$sql = "INSERT INTO #__allwebmenus VALUES ('" . $menutype . "'," . $menutypeopt . ",3)";		
	$database->setQuery($sql);
	$database->query();		
	$xmlpath=dirname(__FILE__);
	$http_host = substr(JURI::base(),0,strpos(JURI::base(),"administrator")); 	
	$XMLdata=genMenu($menutype);
	HTML_allwebmenus::menuExtractFinish( $option, $XMLdata );
}
//this function takes care of producing the correct links.
function AWM_getLink($row){

    $mainframeFront = JApplication::getInstance('site', array(), 'J');
		$id = $row->id;
		$type = $row->type;
		$router = JSite::getRouter();
                $link = "";
                $iParams = new JParameter($row->params);

		switch ($type)
				{
					case 'separator':
                                            $link = $row->link;
						// No further action needed.
						break;

					case 'url':
						if ((strpos($row->link, 'index.php?') === 0) && (strpos($row->link, 'Itemid=') === false)) {
							// If this is an internal Joomla link, ensure the Itemid is set.
							$link = $row->link.'&Itemid='.$id;
						}
                                                else
                                                    $link = $row->link;
						break;
                                                
                                            case 'menulink':
                                                $link = 'index.php?Itemid='.$iParams->get('menu_item');
						break;

					default:
						if ($router->getMode() == JROUTER_MODE_SEF) {
							$link = 'index.php?Itemid='.$id;
						}
						else {
							$link = $row->link . '&Itemid='.$id;
						}
						break;
				}

		if (strcasecmp(substr($link, 0, 4), 'http') && (strpos($link, 'index.php?') !== false)) {

		if ( (strpos($link, '&') !== 0 ) && (strpos($link, 'index.php') !== 0) ) {
                    return htmlspecialchars($link, ENT_QUOTES, 'UTF-8' );
 		}

		// Build route
		$uri = &$router->build($link);
		$link = $uri->toString(array('path', 'query', 'fragment'));
                $link = str_replace(JURI::base(true),JURI::root(true),$link);

		// Replace spaces
		$link = preg_replace('/\s/u', '%20', $link);

		/*
		 * Get the secure/unsecure URLs.

		 * If the first 5 characters of the BASE are 'https', then we are on an ssl connection over
		 * https and need to set our secure URL to the current request URL, if not, and the scheme is
		 * 'http', then we need to do a quick string manipulation to switch schemes.
		 */
		$ssl	= (int) $iParams->get('secure');
		if ( $ssl )
		{
			$uri	         =& JURI::getInstance();

			// Get additional parts
			static $prefix;
			if ( ! $prefix ) {
				$prefix = $uri->toString( array('host', 'port'));
				//$prefix .= JURI::base(true);
			}

			// Determine which scheme we want
			$scheme	= ( $ssl === 1 ) ? 'https' : 'http';

			// Make sure our url path begins with a slash
			if ( ! preg_match('#^/#', $link) ) {
				$link	= '/' . $link;
			}

			// Build the URL
			$link	= $scheme . '://' . $prefix . $link;
		}		

	}
				
				else {

                                    if ( (strpos($link, '&') !== 0 ) && (strpos($link, 'index.php') !== 0) ) {
                    return htmlspecialchars($link, ENT_QUOTES, 'UTF-8' );
 		}

		// Build route
		$uri = &$router->build($link);
		$link = $uri->toString(array('path', 'query', 'fragment'));
                $link = str_replace(JURI::base(true),JURI::root(true),$link);

		// Replace spaces
		$link = preg_replace('/\s/u', '%20', $link);
                
				}
                    return htmlspecialchars($link, ENT_QUOTES, 'UTF-8' );
	}

function genMenu($menutype){
	$curver=getJoomlaVersion();
	$XMLdata="";
	$database = null;		
	$database =& JFactory::getDBO();

	$sql = "SELECT m.* FROM #__allwebmenus AS m WHERE m.menutype='" . $menutype . "' AND category=3";		
	$database->setQuery($sql);
	$rows	= $database->loadObjectList('');
	if (!$database->getErrorNum()) {
	} else {
		$rows	= array();
	}
	if (count($rows)>0)	$typeofmenu=$rows[0]->menuitemid; else $typeofmenu=0;
	if ($typeofmenu==0) {
		$typeofmenufinal="Static";
	} else {
		if ($typeofmenu==1) {
			$typeofmenufinal="Dynamic";
		} else {
			$typeofmenufinal="Mixed";
		}
	}
	

	if ($curver=='1.5') {
		$sql = "SELECT m.* FROM #__menu AS m WHERE m.menutype='" . $menutype . "' AND parent=0 AND published=1 ORDER BY ordering";		
	} else {
		$sql = "SELECT m.* FROM #__menu AS m WHERE m.menutype='" . $menutype . "' AND parent_id=1 AND published=1 ORDER BY ordering";
	}
	$database->setQuery($sql);
	$rows	= $database->loadObjectList('id');
	if (!$database->getErrorNum()) {
	} else {
		$rows	= array();
	}		
	if (count($rows)>0) {
		$sql = "SELECT count(*) AS countobjs FROM #__allwebmenus WHERE menutype='" . $menutype . "' AND menuitemid=0 AND category=1";
		$database->setQuery($sql);
		$myrows	= $database->loadObjectList('');
		if ($myrows[0]->countobjs>0) $excludealltext=1; else $excludealltext=0;

		$sql = "SELECT count(*) AS countobjs FROM #__allwebmenus WHERE menutype='" . $menutype . "' AND menuitemid=0 AND category=2";
		$database->setQuery($sql);
		$myrows	= $database->loadObjectList('');
		if ($myrows[0]->countobjs>0) $excludealllink=1; else $excludealllink=0;
				
		$XMLdata = '<?xml version="1.0" encoding="UTF-8"?><mainmenu>';
		$XMLdata .= '<menutype>' . $typeofmenufinal . '</menutype>';
		$XMLdata .= '<menuname>' . $menutype . '</menuname>';

                foreach(array_keys($rows) as $id) {
			$row =& $rows[$id];
			$id = $row->id;
                        
                        $link = AWM_getLink($row);
			if ($curver=='1.5') {
				$name = htmlspecialchars( $row->name, ENT_QUOTES, 'UTF-8' );
			} else {
				$name = htmlspecialchars( $row->title, ENT_QUOTES, 'UTF-8' );
			}
			$target = $row->browserNav;
			
			$sql = "SELECT count(*) AS countobjs FROM #__allwebmenus WHERE menutype='" . $menutype . "' AND menuitemid=" .$row->id . " AND category=1";
			$database->setQuery($sql);
			$myrows	= $database->loadObjectList('');
			if ($myrows[0]->countobjs>0) $excludetext=1; else $excludetext=0;

			$sql = "SELECT count(*) AS countobjs FROM #__allwebmenus WHERE menutype='" . $menutype . "' AND menuitemid=" .$row->id . " AND category=2";
			$database->setQuery($sql);
			$myrows	= $database->loadObjectList('');
			if ($myrows[0]->countobjs>0) $excludelink=1; else $excludelink=0;
			
			$XMLdata .= "<item><id>$id</id><name>$name</name><link>$link</link>";
			$XMLdata .= "<excludetext>" . (($excludealltext==1 or $excludetext==1) ? 1 : 0) . "</excludetext>";
			$XMLdata .= "<excludelink>" . (($excludealllink==1 or $excludelink==1) ? 1 : 0) . "</excludelink>";
			$XMLdata .= "<target>" . $target . "</target>";
			$XMLdata .= getSubmenus($menutype,$id,$database) . "</item>";
		}
		$XMLdata.= '</mainmenu>';
	}
	return $XMLdata;
}

function getSubmenus($menutype,$parent,$database) {
	$curver=getJoomlaVersion();
	$XMLdata="";
	if ($curver=='1.5') {
		$sql = "SELECT m.* FROM #__menu AS m WHERE m.menutype='" . $menutype . "' AND parent=" . $parent . " AND published=1 ORDER BY ordering";		
	} else {
		$sql = "SELECT m.* FROM #__menu AS m WHERE m.menutype='" . $menutype . "' AND parent_id=" . $parent . " AND published=1 ORDER BY ordering";		
	}
	$database->setQuery($sql);
	$rows	= $database->loadObjectList('id');
	if (!$database->getErrorNum()) {
	} else {
		$rows	= array();
	}		
	if (count($rows)>0) {
		$sql = "SELECT count(*) AS countobjs FROM #__allwebmenus WHERE menutype='" . $menutype . "' AND menuitemid=0 AND category=1";
		$database->setQuery($sql);
		$myrows	= $database->loadObjectList('');
		if ($myrows[0]->countobjs>0) $excludealltext=1; else $excludealltext=0;

		$sql = "SELECT count(*) AS countobjs FROM #__allwebmenus WHERE menutype='" . $menutype . "' AND menuitemid=0 AND category=2";
		$database->setQuery($sql);
		$myrows	= $database->loadObjectList('');
		if ($myrows[0]->countobjs>0) $excludealllink=1; else $excludealllink=0;

		$XMLdata = '<submenu>';
		foreach(array_keys($rows) as $id) {
			$row =& $rows[$id];
			$type = $row->type;
			$id = $row->id;
			$link = AWM_getLink($row);
			if ($curver=='1.5') {			
				$name = htmlspecialchars( $row->name, ENT_QUOTES, 'UTF-8' );
			} else {
				$name = htmlspecialchars( $row->title, ENT_QUOTES, 'UTF-8' );
			}
			$target = $row->browserNav;

			$sql = "SELECT count(*) AS countobjs FROM #__allwebmenus WHERE menutype='" . $menutype . "' AND menuitemid=" .$row->id . " AND category=1";
			$database->setQuery($sql);
			$myrows	= $database->loadObjectList('');
			if ($myrows[0]->countobjs>0) $excludetext=1; else $excludetext=0;

			$sql = "SELECT count(*) AS countobjs FROM #__allwebmenus WHERE menutype='" . $menutype . "' AND menuitemid=" .$row->id . " AND category=2";
			$database->setQuery($sql);
			$myrows	= $database->loadObjectList('');
			if ($myrows[0]->countobjs>0) $excludelink=1; else $excludelink=0;

			$XMLdata.= "<item><id>$id</id><name>$name</name><link>$link</link>";
			$XMLdata .= "<excludetext>" . (($excludealltext==1 or $excludetext==1) ? 1 : 0) . "</excludetext>";
			$XMLdata .= "<excludelink>" . (($excludealllink==1 or $excludelink==1) ? 1 : 0) . "</excludelink>";
			$XMLdata .= "<target>" . $target . "</target>";
			$XMLdata.= getSubmenus($menutype,$id,$database) . "</item>";
		}
		$XMLdata.= '</submenu>';
	}
	return $XMLdata;
}

function getJoomlaVersion() {
	$version = new JVersion;
	return substr($version->getShortVersion(),0,3);
}	

?>
